<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 29.60</title>
    <meta charset="UTF-8">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container jumbotron">
        <h1 class="text-center">Danh sách người dùng đăng ký</h1>
        <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users"
    const gEND_OF_ROW_COL = -1;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý sự kiện loading
    function onPageLoading() {
        "use strict";
        //Gọi server
        var vXHTMLRequest = new XMLHttpRequest();
        callApiGetUsers(vXHTMLRequest);
        vXHTMLRequest.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log("responseText = " + vXHTMLRequest.responseText);  //đây là responses text bạn có thể  phân tích 
                // code xử lý response ở đây
                /*thêm code xử lý hien thi*/
                showDataOnTable(vXHTMLRequest);
                // gắn sự kiện click cho nút chi tiết
                addListonerEventInfoButton();
            }
        };
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm xử lý gọi api send request
    function callApiGetUsers(paramXmlHttp) {
        "use strict";
        paramXmlHttp.open("GET", gBASE_URL, true);
        paramXmlHttp.send();
    }

    //load dữ liệu từ response server trả về vào table, hiện các button Chi tiết
    // input/start:
    // - paramXmlHttpUser: request đã dùng gọi server, và có responseText chữa dữ liệu
    // - dữ liệu hiển thị trên bảng
    // - các button chi tiết được hiển thị và có sẵn dưx liệu dataset
    function showDataOnTable(paramXmlHttpUser) {
        "use strict";
        console.log(paramXmlHttpUser.responseText);
        //chuyển JSON thành object
        var vResponse = JSON.parse(paramXmlHttpUser.responseText);
        var vTable = document.getElementById("user-table");
        var vTableBody = vTable.getElementsByTagName("tbody")[0];
        for (var bI = 0; bI < vResponse.length; bI ++) {
            // tạo dòng mới cho bảng và ghi vào các giá trị
            var vNewRow = vTableBody.insertRow(gEND_OF_ROW_COL);
            var vCellMaNguoiDung = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellFirstName = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellLastName = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellCountry = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellSubject = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellCustomerType = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellRegisterStatus = vNewRow.insertCell(gEND_OF_ROW_COL);
            var vCellUserAction = vNewRow.insertCell(gEND_OF_ROW_COL);

            vCellMaNguoiDung.innerHTML = vResponse[bI].id;
            vCellFirstName.innerHTML = vResponse[bI].firstname;
            vCellLastName.innerHTML = vResponse[bI].lastname;
            vCellCountry.innerHTML = vResponse[bI].country;
            vCellSubject.innerHTML = vResponse[bI].subject;
            vCellCustomerType.innerHTML = vResponse[bI].customerType;
            vCellRegisterStatus.innerHTML = vResponse[bI].registerStatus;
            
            //button chứa data của dòng
            var vDetailButton = document.createElement("button");
            vDetailButton.className = "info-user btn btn-info";
            // thêm dữ liệu dataset cho button
            vDetailButton.setAttribute("data-id", vResponse[bI].id);
            vDetailButton.setAttribute("data-firstname", vResponse[bI].firstname);
            vDetailButton.setAttribute("data-lastname", vResponse[bI].lastname);
            vDetailButton.setAttribute("data-country", vResponse[bI].country);
            vDetailButton.setAttribute("data-subject", vResponse[bI].subject);
            vDetailButton.setAttribute("data-customer-type", vResponse[bI].customerType);
            vDetailButton.setAttribute("data-register-status", vResponse[bI].registerStatus);
            
            vDetailButton.innerHTML = "Chi tiết";
            vCellUserAction.appendChild(vDetailButton);
        }
    }

    // add listner cho event handler (event click chính là onClick)
    // khi ấn nút sẽ gọi function onBtnChiTietClick 
    function addListonerEventInfoButton(){
        //truy xuất tất cả các nút detail qua className
        var vDetailButtons = document.getElementsByClassName("info-user");
        for (var bI = 0; bI < vDetailButtons.length; bI ++) {
            vDetailButtons[bI].addEventListener('click', function () {
                onBtnChiTietClick(this);
            });
        }
    }

    // onBtnChiTietClick
    function onBtnChiTietClick(paramDetailButton) {
        //thu thập dữ liệu
        var vUserId = paramDetailButton.dataset.id;
        var vFirstName = paramDetailButton.dataset.firstname;
        var vLastName = paramDetailButton.dataset.lastname;
        var vCountry = paramDetailButton.dataset.country;
        var vSubject = paramDetailButton.dataset.subject;
        var vCustomerType = paramDetailButton.dataset.customerType;
        var vRegisterStatus = paramDetailButton.dataset.registerStatus;

        console.log("Thông tin user");
        console.log("User id: ", vUserId);
        console.log("First name: ", vFirstName);
        console.log("Last name: ", vLastName);
        console.log("Country: ", vCountry);
        console.log("Subject: ", vSubject);
        console.log("Customer Type: ", vCustomerType);
        console.log("Register Status: ", vRegisterStatus);
    }
</script>

</html>